// src/internal/persistent-port.ts
import browser from "webextension-polyfill";
var PersistentPort = class {
  constructor(name = "") {
    this.name = name;
    this.onMessageListeners = /* @__PURE__ */ new Set();
    this.invokeOnMessageListeners = (message, port) => {
      this.onMessageListeners.forEach((cb) => cb(message, port));
    };
    this.connect = () => {
      this.port = browser.runtime.connect({ name: this.name });
      this.port.onMessage.addListener(this.invokeOnMessageListeners);
      this.port.onDisconnect.addListener(this.connect);
    };
    this.connect();
  }
  onMessage(cb) {
    this.onMessageListeners.add(cb);
  }
  postMessage(message) {
    this.port.postMessage(message);
  }
};

export {
  PersistentPort
};
